
local _, YssBossLoot = ...

if not YssBossLoot then
	_GYssBossLoot = _GYssBossLoot or {}
	YssBossLoot = _GYssBossLoot
end

local L = LibStub("AceLocale-3.0"):GetLocale("YssBossLoot", true)
local BZ = LibStub("LibBabble-Zone-3.0", true):GetUnstrictLookupTable()
local BB = LibStub("LibBabble-Boss-3.0", true):GetUnstrictLookupTable()

YssBossLoot.YssBossLootFrame = CreateFrame("frame", "YssBossLootFrame", UIParent)
local YssBossLootFrame = YssBossLoot.YssBossLootFrame
YssBossLootFrame:Hide()
	tinsert(UISpecialFrames,"YssBossLootFrame")
	YssBossLootFrame:SetFrameStrata("HIGH")
	YssBossLootFrame:SetWidth(1024)
	YssBossLootFrame:SetHeight(768)
	YssBossLootFrame:EnableMouse(true)
	YssBossLootFrame:SetMovable(true)
	YssBossLootFrame:RegisterForDrag("LeftButton")
	YssBossLootFrame:SetScript("OnDragStart", function(self) self:StartMoving() end)
	YssBossLootFrame:SetScript("OnDragStop", function(self)
		self:StopMovingOrSizing()
		x = self:GetLeft()
		y = self:GetTop() - (GetScreenHeight() * (UIParent:GetEffectiveScale() / self:GetEffectiveScale()))
		self:ClearAllPoints()
		self:SetPoint("TOPLEFT", UIParent, "TOPLEFT", x, y) -- always anchor to top left this helps us with our resizing
		YssBossLoot.db.profile.frame.x = x
		YssBossLoot.db.profile.frame.y = y
	end)

	YssBossLootFrame.TypeDropdown = CreateFrame("frame", nil, YssBossLootFrame)
		YssBossLootFrame.TypeDropdown:SetWidth(180)
		YssBossLootFrame.TypeDropdown:SetHeight(32)
		YssBossLootFrame.TypeDropdown:SetPoint("TOPRIGHT", YssBossLootFrame, "TOP", -5, -35)
		YssBossLootFrame.TypeDropdown.leftart = YssBossLootFrame.TypeDropdown:CreateTexture(nil, 'ARTWORK')
			YssBossLootFrame.TypeDropdown.leftart:SetWidth(25)
			YssBossLootFrame.TypeDropdown.leftart:SetHeight(64)
			YssBossLootFrame.TypeDropdown.leftart:SetPoint("TOPLEFT", 0, 17)
			YssBossLootFrame.TypeDropdown.leftart:SetTexture([[Interface\Glues\CharacterCreate\CharacterCreate-LabelFrame]])
			YssBossLootFrame.TypeDropdown.leftart:SetTexCoord(0,0.1953125,0,1)
		YssBossLootFrame.TypeDropdown.middleart = YssBossLootFrame.TypeDropdown:CreateTexture(nil, 'ARTWORK')
			YssBossLootFrame.TypeDropdown.middleart:SetWidth(130)
			YssBossLootFrame.TypeDropdown.middleart:SetHeight(64)
			YssBossLootFrame.TypeDropdown.middleart:SetPoint("LEFT", YssBossLootFrame.TypeDropdown.leftart, "RIGHT")
			YssBossLootFrame.TypeDropdown.middleart:SetTexture([[Interface\Glues\CharacterCreate\CharacterCreate-LabelFrame]])
			YssBossLootFrame.TypeDropdown.middleart:SetTexCoord(0.1953125,0.8046875,0,1)
		YssBossLootFrame.TypeDropdown.rightart = YssBossLootFrame.TypeDropdown:CreateTexture(nil, 'ARTWORK')
			YssBossLootFrame.TypeDropdown.rightart:SetWidth(25)
			YssBossLootFrame.TypeDropdown.rightart:SetHeight(64)
			YssBossLootFrame.TypeDropdown.rightart:SetPoint("LEFT", YssBossLootFrame.TypeDropdown.middleart, "RIGHT")
			YssBossLootFrame.TypeDropdown.rightart:SetTexture([[Interface\Glues\CharacterCreate\CharacterCreate-LabelFrame]])
			YssBossLootFrame.TypeDropdown.rightart:SetTexCoord(0.8046875,1,0,1)
		YssBossLootFrame.TypeDropdown.text = YssBossLootFrame.TypeDropdown:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
			YssBossLootFrame.TypeDropdown.text:SetHeight(10)
			YssBossLootFrame.TypeDropdown.text:SetPoint("RIGHT", YssBossLootFrame.TypeDropdown.rightart, -43, 2)
			YssBossLootFrame.TypeDropdown.text:SetPoint("LEFT", YssBossLootFrame.TypeDropdown.leftart, 25, 2)
			YssBossLootFrame.TypeDropdown.text:SetJustifyH("RIGHT")
		YssBossLootFrame.TypeDropdown.desc = YssBossLootFrame.TypeDropdown:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
			YssBossLootFrame.TypeDropdown.desc:SetHeight(10)
			YssBossLootFrame.TypeDropdown.desc:SetPoint("TOPLEFT", 20, 10)
			YssBossLootFrame.TypeDropdown.desc:SetText('Instance Type')
		YssBossLootFrame.TypeDropdown.button = CreateFrame("Button", nil, YssBossLootFrame.TypeDropdown)
			YssBossLootFrame.TypeDropdown.button:SetWidth(24)
			YssBossLootFrame.TypeDropdown.button:SetHeight(24)
			YssBossLootFrame.TypeDropdown.button.type = 'type'
			YssBossLootFrame.TypeDropdown.button:SetPoint("TOPRIGHT", YssBossLootFrame.TypeDropdown.rightart, -16, -18)
			YssBossLootFrame.TypeDropdown.button:SetNormalTexture([[Interface\ChatFrame\UI-ChatIcon-ScrollDown-Up]])
			YssBossLootFrame.TypeDropdown.button:SetPushedTexture([[Interface\ChatFrame\UI-ChatIcon-ScrollDown-Down]])
			YssBossLootFrame.TypeDropdown.button:SetHighlightTexture([[Interface\Buttons\UI-Common-MouseHilight]], "ADD")
			YssBossLootFrame.TypeDropdown.button:SetDisabledTexture([[Interface\ChatFrame\UI-ChatIcon-ScrollDown-Disabled]])

	YssBossLootFrame.ZoneDropdown = CreateFrame("frame", nil, YssBossLootFrame)
		YssBossLootFrame.ZoneDropdown:SetWidth(180)
		YssBossLootFrame.ZoneDropdown:SetHeight(32)
		YssBossLootFrame.ZoneDropdown:SetPoint("TOPLEFT", YssBossLootFrame, "TOP", 5, -35)
		YssBossLootFrame.ZoneDropdown.leftart = YssBossLootFrame.ZoneDropdown:CreateTexture(nil, 'ARTWORK')
			YssBossLootFrame.ZoneDropdown.leftart:SetWidth(25)
			YssBossLootFrame.ZoneDropdown.leftart:SetHeight(64)
			YssBossLootFrame.ZoneDropdown.leftart:SetPoint("TOPLEFT", 0, 17)
			YssBossLootFrame.ZoneDropdown.leftart:SetTexture([[Interface\Glues\CharacterCreate\CharacterCreate-LabelFrame]])
			YssBossLootFrame.ZoneDropdown.leftart:SetTexCoord(0,0.1953125,0,1)
		YssBossLootFrame.ZoneDropdown.middleart = YssBossLootFrame.ZoneDropdown:CreateTexture(nil, 'ARTWORK')
			YssBossLootFrame.ZoneDropdown.middleart:SetWidth(130)
			YssBossLootFrame.ZoneDropdown.middleart:SetHeight(64)
			YssBossLootFrame.ZoneDropdown.middleart:SetPoint("LEFT", YssBossLootFrame.ZoneDropdown.leftart, "RIGHT")
			YssBossLootFrame.ZoneDropdown.middleart:SetTexture([[Interface\Glues\CharacterCreate\CharacterCreate-LabelFrame]])
			YssBossLootFrame.ZoneDropdown.middleart:SetTexCoord(0.1953125,0.8046875,0,1)
		YssBossLootFrame.ZoneDropdown.rightart = YssBossLootFrame.ZoneDropdown:CreateTexture(nil, 'ARTWORK')
			YssBossLootFrame.ZoneDropdown.rightart:SetWidth(25)
			YssBossLootFrame.ZoneDropdown.rightart:SetHeight(64)
			YssBossLootFrame.ZoneDropdown.rightart:SetPoint("LEFT", YssBossLootFrame.ZoneDropdown.middleart, "RIGHT")
			YssBossLootFrame.ZoneDropdown.rightart:SetTexture([[Interface\Glues\CharacterCreate\CharacterCreate-LabelFrame]])
			YssBossLootFrame.ZoneDropdown.rightart:SetTexCoord(0.8046875,1,0,1)
		YssBossLootFrame.ZoneDropdown.text = YssBossLootFrame.ZoneDropdown:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
			YssBossLootFrame.ZoneDropdown.text:SetHeight(10)
			YssBossLootFrame.ZoneDropdown.text:SetPoint("RIGHT", YssBossLootFrame.ZoneDropdown.rightart, -43, 2)
			YssBossLootFrame.ZoneDropdown.text:SetPoint("LEFT", YssBossLootFrame.ZoneDropdown.leftart, 25, 2)
			YssBossLootFrame.ZoneDropdown.text:SetJustifyH("RIGHT")
		YssBossLootFrame.ZoneDropdown.desc = YssBossLootFrame.ZoneDropdown:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
			YssBossLootFrame.ZoneDropdown.desc:SetHeight(10)
			YssBossLootFrame.ZoneDropdown.desc:SetPoint("TOPLEFT", 20, 10)
			YssBossLootFrame.ZoneDropdown.desc:SetText(ZONE)
		YssBossLootFrame.ZoneDropdown.button = CreateFrame("Button", nil, YssBossLootFrame.ZoneDropdown)
			YssBossLootFrame.ZoneDropdown.button:SetWidth(24)
			YssBossLootFrame.ZoneDropdown.button:SetHeight(24)
			YssBossLootFrame.ZoneDropdown.button.type = 'zone'
			YssBossLootFrame.ZoneDropdown.button:SetPoint("TOPRIGHT", YssBossLootFrame.ZoneDropdown.rightart, -16, -18)
			YssBossLootFrame.ZoneDropdown.button:SetNormalTexture([[Interface\ChatFrame\UI-ChatIcon-ScrollDown-Up]])
			YssBossLootFrame.ZoneDropdown.button:SetPushedTexture([[Interface\ChatFrame\UI-ChatIcon-ScrollDown-Down]])
			YssBossLootFrame.ZoneDropdown.button:SetHighlightTexture([[Interface\Buttons\UI-Common-MouseHilight]], "ADD")
			YssBossLootFrame.ZoneDropdown.button:SetDisabledTexture([[Interface\ChatFrame\UI-ChatIcon-ScrollDown-Disabled]])

	YssBossLootFrame.LevelDropdown = CreateFrame("frame", nil, YssBossLootFrame)
		YssBossLootFrame.LevelDropdown:SetWidth(180)
		YssBossLootFrame.LevelDropdown:SetHeight(32)
		YssBossLootFrame.LevelDropdown:SetPoint("TOPRIGHT", YssBossLootFrame, "TOPRIGHT", -20, -35)
		YssBossLootFrame.LevelDropdown.leftart = YssBossLootFrame.LevelDropdown:CreateTexture(nil, 'ARTWORK')
			YssBossLootFrame.LevelDropdown.leftart:SetWidth(25)
			YssBossLootFrame.LevelDropdown.leftart:SetHeight(64)
			YssBossLootFrame.LevelDropdown.leftart:SetPoint("TOPLEFT", 0, 17)
			YssBossLootFrame.LevelDropdown.leftart:SetTexture([[Interface\Glues\CharacterCreate\CharacterCreate-LabelFrame]])
			YssBossLootFrame.LevelDropdown.leftart:SetTexCoord(0,0.1953125,0,1)
		YssBossLootFrame.LevelDropdown.middleart = YssBossLootFrame.LevelDropdown:CreateTexture(nil, 'ARTWORK')
			YssBossLootFrame.LevelDropdown.middleart:SetWidth(130)
			YssBossLootFrame.LevelDropdown.middleart:SetHeight(64)
			YssBossLootFrame.LevelDropdown.middleart:SetPoint("LEFT", YssBossLootFrame.LevelDropdown.leftart, "RIGHT")
			YssBossLootFrame.LevelDropdown.middleart:SetTexture([[Interface\Glues\CharacterCreate\CharacterCreate-LabelFrame]])
			YssBossLootFrame.LevelDropdown.middleart:SetTexCoord(0.1953125,0.8046875,0,1)
		YssBossLootFrame.LevelDropdown.rightart = YssBossLootFrame.LevelDropdown:CreateTexture(nil, 'ARTWORK')
			YssBossLootFrame.LevelDropdown.rightart:SetWidth(25)
			YssBossLootFrame.LevelDropdown.rightart:SetHeight(64)
			YssBossLootFrame.LevelDropdown.rightart:SetPoint("LEFT", YssBossLootFrame.LevelDropdown.middleart, "RIGHT")
			YssBossLootFrame.LevelDropdown.rightart:SetTexture([[Interface\Glues\CharacterCreate\CharacterCreate-LabelFrame]])
			YssBossLootFrame.LevelDropdown.rightart:SetTexCoord(0.8046875,1,0,1)
		YssBossLootFrame.LevelDropdown.text = YssBossLootFrame.LevelDropdown:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
			YssBossLootFrame.LevelDropdown.text:SetHeight(10)
			YssBossLootFrame.LevelDropdown.text:SetPoint("RIGHT", YssBossLootFrame.LevelDropdown.rightart, -43, 2)
			YssBossLootFrame.LevelDropdown.text:SetPoint("LEFT", YssBossLootFrame.LevelDropdown.leftart, 25, 2)
			YssBossLootFrame.LevelDropdown.text:SetJustifyH("RIGHT")
		YssBossLootFrame.LevelDropdown.desc = YssBossLootFrame.LevelDropdown:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
			YssBossLootFrame.LevelDropdown.desc:SetHeight(10)
			YssBossLootFrame.LevelDropdown.desc:SetPoint("TOPLEFT", 20, 10)
			YssBossLootFrame.LevelDropdown.desc:SetText(FLOOR)
		YssBossLootFrame.LevelDropdown.button = CreateFrame("Button", nil, YssBossLootFrame.LevelDropdown)
			YssBossLootFrame.LevelDropdown.button:SetWidth(24)
			YssBossLootFrame.LevelDropdown.button:SetHeight(24)
			YssBossLootFrame.LevelDropdown.button.type = 'level'
			YssBossLootFrame.LevelDropdown.button:SetPoint("TOPRIGHT", YssBossLootFrame.LevelDropdown.rightart, -16, -18)
			YssBossLootFrame.LevelDropdown.button:SetNormalTexture([[Interface\ChatFrame\UI-ChatIcon-ScrollDown-Up]])
			YssBossLootFrame.LevelDropdown.button:SetPushedTexture([[Interface\ChatFrame\UI-ChatIcon-ScrollDown-Down]])
			YssBossLootFrame.LevelDropdown.button:SetHighlightTexture([[Interface\Buttons\UI-Common-MouseHilight]], "ADD")
			YssBossLootFrame.LevelDropdown.button:SetDisabledTexture([[Interface\ChatFrame\UI-ChatIcon-ScrollDown-Disabled]])

	local BGT1 = YssBossLootFrame:CreateTexture(nil, 'BACKGROUND')
		BGT1:SetWidth(256)
		BGT1:SetHeight(256)
		BGT1:SetPoint("TOPLEFT", YssBossLootFrame, "CENTER", -512, 384)
		BGT1:SetTexture("Interface\\WorldMap\\UI-WorldMap-Top1")
	local BGT2 = YssBossLootFrame:CreateTexture(nil, 'BACKGROUND')
		BGT2:SetWidth(256)
		BGT2:SetHeight(256)
		BGT2:SetPoint("TOPLEFT", YssBossLootFrame, "CENTER", -256, 384)
		BGT2:SetTexture("Interface\\WorldMap\\UI-WorldMap-Top2")
	local BGT3 = YssBossLootFrame:CreateTexture(nil, 'BACKGROUND')
		BGT3:SetWidth(256)
		BGT3:SetHeight(256)
		BGT3:SetPoint("TOPLEFT", YssBossLootFrame, "CENTER", 0, 384)
		BGT3:SetTexture("Interface\\WorldMap\\UI-WorldMap-Top3")
	local BGT4 = YssBossLootFrame:CreateTexture(nil, 'BACKGROUND')
		BGT4:SetWidth(256)
		BGT4:SetHeight(256)
		BGT4:SetPoint("TOPLEFT", YssBossLootFrame, "CENTER", 256, 384)
		BGT4:SetTexture("Interface\\WorldMap\\UI-WorldMap-Top4")
	local BGM1 = YssBossLootFrame:CreateTexture(nil, 'BACKGROUND')
		BGM1:SetWidth(256)
		BGM1:SetHeight(256)
		BGM1:SetPoint("TOPLEFT", YssBossLootFrame, "CENTER", -512, 128)
		BGM1:SetTexture("Interface\\WorldMap\\UI-WorldMap-Middle1")
	local BGM2 = YssBossLootFrame:CreateTexture(nil, 'BACKGROUND')
		BGM2:SetWidth(256)
		BGM2:SetHeight(256)
		BGM2:SetPoint("TOPLEFT", YssBossLootFrame, "CENTER", -256, 128)
		BGM2:SetTexture("Interface\\WorldMap\\UI-WorldMap-Middle2")
	local BGM3 = YssBossLootFrame:CreateTexture(nil, 'BACKGROUND')
		BGM3:SetWidth(256)
		BGM3:SetHeight(256)
		BGM3:SetPoint("TOPLEFT", YssBossLootFrame, "CENTER", 0, 128)
		BGM3:SetTexture("Interface\\WorldMap\\UI-WorldMap-Middle3")
	local BGM4 = YssBossLootFrame:CreateTexture(nil, 'BACKGROUND')
		BGM4:SetWidth(256)
		BGM4:SetHeight(256)
		BGM4:SetPoint("TOPLEFT", YssBossLootFrame, "CENTER", 256, 128)
		BGM4:SetTexture("Interface\\WorldMap\\UI-WorldMap-Middle4")
	local BGB1 = YssBossLootFrame:CreateTexture(nil, 'BACKGROUND')
		BGB1:SetWidth(256)
		BGB1:SetHeight(256)
		BGB1:SetPoint("TOPLEFT", YssBossLootFrame, "CENTER", -512, -128)
		BGB1:SetTexture("Interface\\WorldMap\\UI-WorldMap-Bottom1")
	local BGB2 = YssBossLootFrame:CreateTexture(nil, 'BACKGROUND')
		BGB2:SetWidth(256)
		BGB2:SetHeight(256)
		BGB2:SetPoint("TOPLEFT", YssBossLootFrame, "CENTER", -256, -128)
		BGB2:SetTexture("Interface\\WorldMap\\UI-WorldMap-Bottom2")
	local BGB3 = YssBossLootFrame:CreateTexture(nil, 'BACKGROUND')
		BGB3:SetWidth(256)
		BGB3:SetHeight(256)
		BGB3:SetPoint("TOPLEFT", YssBossLootFrame, "CENTER", 0, -128)
		BGB3:SetTexture("Interface\\WorldMap\\UI-WorldMap-Bottom3")
	local BGB4 = YssBossLootFrame:CreateTexture(nil, 'BACKGROUND')
		BGB4:SetWidth(256)
		BGB4:SetHeight(256)
		BGB4:SetPoint("TOPLEFT", YssBossLootFrame, "CENTER", 256, -128)
		BGB4:SetTexture("Interface\\WorldMap\\UI-WorldMap-Bottom4")
	local cursorCoords = YssBossLootFrame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		cursorCoords:SetPoint("RIGHT", YssBossLootFrame, "CENTER", 0, -367)

local YssBossLootFrameCloseButton = CreateFrame("Button", nil, YssBossLootFrame)
	YssBossLootFrameCloseButton:SetWidth(32)
	YssBossLootFrameCloseButton:SetHeight(32)
	YssBossLootFrameCloseButton:SetNormalTexture([[Interface\Buttons\UI-Panel-MinimizeButton-Up]])
	YssBossLootFrameCloseButton:SetPushedTexture([[Interface\Buttons\UI-Panel-MinimizeButton-Down]])
	YssBossLootFrameCloseButton:SetHighlightTexture([[Interface\Buttons\UI-Panel-MinimizeButton-Highlight]], 'ADD')
	YssBossLootFrameCloseButton:SetPoint('TOPRIGHT', YssBossLootFrame, 'TOP', 516,4)
	YssBossLootFrameCloseButton:SetScript('OnClick', function() YssBossLootFrame:Hide() end)

local scaler = CreateFrame("Frame", nil, YssBossLootFrame)
	scaler:SetPoint("BOTTOMRIGHT",YssBossLootFrame,"BOTTOMRIGHT",0,0)
	scaler:SetWidth(28)
	scaler:SetHeight(28)
	scaler:EnableMouse()

	scaler.Texture = scaler:CreateTexture(nil, "BACKGROUND")
		scaler.Texture:SetWidth(20)
		scaler.Texture:SetHeight(20)
		scaler.Texture:SetPoint("BOTTOMRIGHT", -4, 4)
		scaler.Texture:SetTexture([[Interface\BUTTONS\UI-AutoCastableOverlay]])
		scaler.Texture:SetTexCoord(0.619, 0.760, 0.612, 0.762)
		scaler.Texture:SetDesaturated(true)

	local mousetracker = CreateFrame("Frame", nil ,UIParent)
		mousetracker:SetFrameStrata("TOOLTIP")
		mousetracker:SetAllPoints(scaler)
		mousetracker:EnableMouse(true)
		mousetracker:SetScript("OnEnter", function()
			scaler.Texture:SetDesaturated(false)
		end)
		mousetracker:SetScript("OnLeave", function()
			scaler.Texture:SetDesaturated(true)
		end)

		local ScalerOriginalState = {
			dist = 0,
			width = 0,
			height = 0,
			left = 0,
			top = 0,
			scale = 1,
		}
		local function GetScaleDistance() -- distance from cursor to TopLeft :)
			local left, top = ScalerOriginalState.left, ScalerOriginalState.top
			local scale = ScalerOriginalState.EFscale

			local x, y = GetCursorPosition()
			local cx = x/scale - left
			local cy = top - y/scale

			return sqrt(cx*cx+cy*cy)
		end

		mousetracker:SetScript("OnMouseUp", function(self)
				self:SetScript("OnUpdate", nil)
				self:SetAllPoints(scaler)
			end)
		mousetracker:SetScript("OnMouseDown",function(self)
				ScalerOriginalState.left, ScalerOriginalState.top = YssBossLootFrame:GetLeft(), YssBossLootFrame:GetTop()
				ScalerOriginalState.cx, ScalerOriginalState.cy = select(4, YssBossLootFrame:GetPoint())
				ScalerOriginalState.EFscale = YssBossLootFrame:GetEffectiveScale()
				ScalerOriginalState.scale = YssBossLootFrame:GetScale()
				ScalerOriginalState.dist = GetScaleDistance()
				self:SetScript("OnUpdate", function(self)
						local scale = GetScaleDistance()/ScalerOriginalState.dist*ScalerOriginalState.scale
						if scale < .2 then scale = .2
						elseif scale > 1 then scale = 1
						end
						YssBossLootFrame:SetScale(scale)

						local s = ScalerOriginalState.scale/YssBossLootFrame:GetScale()
						local x = ScalerOriginalState.cx*s
						local y = ScalerOriginalState.cy*s
						YssBossLootFrame:ClearAllPoints()
						YssBossLootFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", x, y)
						YssBossLoot.db.profile.frame.scale = scale
						YssBossLoot.db.profile.frame.x = x
						YssBossLoot.db.profile.frame.y = y
					end)
				self:SetAllPoints(UIParent)
			end)
	YssBossLootFrame.DetailFrame = CreateFrame('Frame', 'YssBossLootDetailFrame', YssBossLootFrame)
		YssBossLootFrame.DetailFrame:SetWidth(1002)
		YssBossLootFrame.DetailFrame:SetHeight(668)
		YssBossLootFrame.DetailFrame:EnableMouse(true)
		YssBossLootFrame.DetailFrame:SetPoint('TOPLEFT', YssBossLootFrame, 'TOP', -502, -69)
		YssBossLootFrame.DetailFrame.Tiles = {}

		YssBossLootFrame.DetailFrame.Tiles[1] = YssBossLootFrame.DetailFrame:CreateTexture(nil, 'BACKGROUND')
			YssBossLootFrame.DetailFrame.Tiles[1]:SetWidth(256)
			YssBossLootFrame.DetailFrame.Tiles[1]:SetHeight(256)
			YssBossLootFrame.DetailFrame.Tiles[1]:SetPoint("TOPLEFT")
		YssBossLootFrame.DetailFrame.Tiles[2] = YssBossLootFrame.DetailFrame:CreateTexture(nil, 'BACKGROUND')
			YssBossLootFrame.DetailFrame.Tiles[2]:SetWidth(256)
			YssBossLootFrame.DetailFrame.Tiles[2]:SetHeight(256)
			YssBossLootFrame.DetailFrame.Tiles[2]:SetPoint("TOPLEFT", YssBossLootFrame.DetailFrame.Tiles[1], "TOPRIGHT")
		YssBossLootFrame.DetailFrame.Tiles[3] = YssBossLootFrame.DetailFrame:CreateTexture(nil, 'BACKGROUND')
			YssBossLootFrame.DetailFrame.Tiles[3]:SetWidth(256)
			YssBossLootFrame.DetailFrame.Tiles[3]:SetHeight(256)
			YssBossLootFrame.DetailFrame.Tiles[3]:SetPoint("TOPLEFT", YssBossLootFrame.DetailFrame.Tiles[2], "TOPRIGHT")
		YssBossLootFrame.DetailFrame.Tiles[4] = YssBossLootFrame.DetailFrame:CreateTexture(nil, 'BACKGROUND')
			YssBossLootFrame.DetailFrame.Tiles[4]:SetWidth(256)
			YssBossLootFrame.DetailFrame.Tiles[4]:SetHeight(256)
			YssBossLootFrame.DetailFrame.Tiles[4]:SetPoint("TOPLEFT", YssBossLootFrame.DetailFrame.Tiles[3], "TOPRIGHT")
		YssBossLootFrame.DetailFrame.Tiles[5] = YssBossLootFrame.DetailFrame:CreateTexture(nil, 'BACKGROUND')
			YssBossLootFrame.DetailFrame.Tiles[5]:SetWidth(256)
			YssBossLootFrame.DetailFrame.Tiles[5]:SetHeight(256)
			YssBossLootFrame.DetailFrame.Tiles[5]:SetPoint("TOPLEFT", YssBossLootFrame.DetailFrame.Tiles[1], "BOTTOMLEFT")
		YssBossLootFrame.DetailFrame.Tiles[6] = YssBossLootFrame.DetailFrame:CreateTexture(nil, 'BACKGROUND')
			YssBossLootFrame.DetailFrame.Tiles[6]:SetWidth(256)
			YssBossLootFrame.DetailFrame.Tiles[6]:SetHeight(256)
			YssBossLootFrame.DetailFrame.Tiles[6]:SetPoint("TOPLEFT", YssBossLootFrame.DetailFrame.Tiles[5], "TOPRIGHT")
		YssBossLootFrame.DetailFrame.Tiles[7] = YssBossLootFrame.DetailFrame:CreateTexture(nil, 'BACKGROUND')
			YssBossLootFrame.DetailFrame.Tiles[7]:SetWidth(256)
			YssBossLootFrame.DetailFrame.Tiles[7]:SetHeight(256)
			YssBossLootFrame.DetailFrame.Tiles[7]:SetPoint("TOPLEFT", YssBossLootFrame.DetailFrame.Tiles[6], "TOPRIGHT")
		YssBossLootFrame.DetailFrame.Tiles[8] = YssBossLootFrame.DetailFrame:CreateTexture(nil, 'BACKGROUND')
			YssBossLootFrame.DetailFrame.Tiles[8]:SetWidth(256)
			YssBossLootFrame.DetailFrame.Tiles[8]:SetHeight(256)
			YssBossLootFrame.DetailFrame.Tiles[8]:SetPoint("TOPLEFT", YssBossLootFrame.DetailFrame.Tiles[7], "TOPRIGHT")
		YssBossLootFrame.DetailFrame.Tiles[9] = YssBossLootFrame.DetailFrame:CreateTexture(nil, 'BACKGROUND')
			YssBossLootFrame.DetailFrame.Tiles[9]:SetWidth(256)
			YssBossLootFrame.DetailFrame.Tiles[9]:SetHeight(256)
			YssBossLootFrame.DetailFrame.Tiles[9]:SetPoint("TOPLEFT", YssBossLootFrame.DetailFrame.Tiles[5], "BOTTOMLEFT")
		YssBossLootFrame.DetailFrame.Tiles[10] = YssBossLootFrame.DetailFrame:CreateTexture(nil, 'BACKGROUND')
			YssBossLootFrame.DetailFrame.Tiles[10]:SetWidth(256)
			YssBossLootFrame.DetailFrame.Tiles[10]:SetHeight(256)
			YssBossLootFrame.DetailFrame.Tiles[10]:SetPoint("TOPLEFT", YssBossLootFrame.DetailFrame.Tiles[9], "TOPRIGHT")
		YssBossLootFrame.DetailFrame.Tiles[11] = YssBossLootFrame.DetailFrame:CreateTexture(nil, 'BACKGROUND')
			YssBossLootFrame.DetailFrame.Tiles[11]:SetWidth(256)
			YssBossLootFrame.DetailFrame.Tiles[11]:SetHeight(256)
			YssBossLootFrame.DetailFrame.Tiles[11]:SetPoint("TOPLEFT", YssBossLootFrame.DetailFrame.Tiles[10], "TOPRIGHT")
		YssBossLootFrame.DetailFrame.Tiles[12] = YssBossLootFrame.DetailFrame:CreateTexture(nil, 'BACKGROUND')
			YssBossLootFrame.DetailFrame.Tiles[12]:SetWidth(256)
			YssBossLootFrame.DetailFrame.Tiles[12]:SetHeight(256)
			YssBossLootFrame.DetailFrame.Tiles[12]:SetPoint("TOPLEFT", YssBossLootFrame.DetailFrame.Tiles[11], "TOPRIGHT")

		YssBossLootFrame.DetailFrame:SetScript('OnUpdate', function(self)
				local left, top = self:GetLeft(), self:GetTop()
				local width, height = self:GetWidth(), self:GetHeight()
				local scale = self:GetEffectiveScale()

				local x, y = GetCursorPosition()
				x = (x/scale - left) / width
				y = (top - y/scale) / height

				if x < 0 or x > 1 or y < 0 or y > 1 then
					return cursorCoords:SetText('')
				end
				cursorCoords:SetFormattedText("%.2f, %.2f", 100 * x, 100 * y)
		end)
		
local function setupRotationTexture(texture, duration)
	texture:SetPoint("CENTER", YssBossLootFrame.DetailFrame)
	texture:SetBlendMode("ADD")
	texture:SetAlpha(.5)
	local animGroup = texture:CreateAnimationGroup()
	local Rotation = animGroup:CreateAnimation("Rotation")
		animGroup:SetLooping("REPEAT")
		Rotation:SetDuration(duration)
		Rotation:SetOrder(1)
		Rotation:SetDegrees(-360)
		Rotation:SetOrigin("CENTER", 0, 0)
		animGroup.Rotation = Rotation
	animGroup:Play()
	return animGroup
end

local Swirl_anim = {}
	Swirl_anim[1] = YssBossLootFrame:CreateTexture(nil, 'ARTWORK')
		Swirl_anim[1]:SetWidth(600)
		Swirl_anim[1]:SetHeight(600)
		Swirl_anim[1]:SetTexture([[Interface\Addons\YssBossLoot\Art\twirl]])
		Swirl_anim[1].anim = setupRotationTexture(Swirl_anim[1], 8)
	Swirl_anim[2] = YssBossLootFrame:CreateTexture(nil, 'ARTWORK')
		Swirl_anim[2]:SetWidth(350)
		Swirl_anim[2]:SetHeight(350)
		Swirl_anim[2]:SetTexture([[Interface\Addons\YssBossLoot\Art\twirl]])
		Swirl_anim[2].anim = setupRotationTexture(Swirl_anim[2], 6)
	Swirl_anim[3] = YssBossLootFrame:CreateTexture(nil, 'ARTWORK')
		Swirl_anim[3]:SetWidth(200)
		Swirl_anim[3]:SetHeight(200)
		Swirl_anim[3]:SetTexture([[Interface\Addons\YssBossLoot\Art\twirl]])
		Swirl_anim[3].anim = setupRotationTexture(Swirl_anim[3], 4)

function YssBossLoot:SetMap(mapFileName, dungeonLevel)
	if mapFileName and dungeonLevel then
		local completeMapFileName
		if ( dungeonLevel > 0 ) then
			completeMapFileName = mapFileName..dungeonLevel.."_"
		else
			completeMapFileName = mapFileName
		end
		for i=1, NUM_WORLDMAP_DETAIL_TILES do
			YssBossLootFrame.DetailFrame.Tiles[i]:SetTexture("Interface\\WorldMap\\"..mapFileName.."\\"..completeMapFileName..i)
		end
	else
		for i=1, NUM_WORLDMAP_DETAIL_TILES do
			YssBossLootFrame.DetailFrame.Tiles[i]:SetTexture(nil)
		end
	end
	self:ClearBosses(YssBossLootFrame.DetailFrame)
	enableLootTooltip = false
	self.LootFrame:Hide()
end


YssBossLoot.DropDownMenu = CreateFrame("Frame", "YssBossLoot_DropDownMenu", YssBossLoot.frame)
YssBossLoot.DropDownMenu.onHide = function(...)
	MenuParent = nil
	MenuItem = nil
	MenuEquipSlot = nil
end

local info = {}
YssBossLoot.DropDownMenu.initialize = function(self, level)
	if not level then return end
	wipe(info)
	if dropdowntype == 'type' then
		local names = {}
		local RLnames = {}
		for name, Lname in pairs(YssBossLoot.MapTypes) do
			names[#names+1] = Lname
			RLnames[Lname] = name
		end
		table.sort(names)

		for i = 1, #names do
			info.text = names[i]
			info.arg1 = RLnames[names[i]]
			info.arg2 = names[i]
			info.func = function(button, arg1, arg2)
				if arg1 ~= YssBossLoot.db.profile.maptype then
					YssBossLoot.db.profile.maptype = arg1
					YssBossLoot:SetMap(nil)
					YssBossLootFrame.TypeDropdown.text:SetText(arg2)
					YssBossLoot.db.profile.zone = nil
					YssBossLootFrame.ZoneDropdown.text:SetText('')
				end
				YssBossLootFrame.LevelDropdown:Hide()
			end
			info.checked = RLnames[names[i]] == YssBossLoot.db.profile.maptype
			UIDropDownMenu_AddButton(info, level)
		end
	elseif dropdowntype == 'zone' then
		local names = {}
		local RLnames = {}
		for name, tex in pairs(YssBossLoot.Maps[YssBossLoot.db.profile.maptype]) do
			names[#names+1] = BZ[name] or name
			RLnames[BZ[name] or name] = name
		end
		table.sort(names)

		for i = 1, #names do
			info.text = names[i]
			info.arg1 = RLnames[names[i]]
			info.arg2 = names[i]
			info.func = function(button, arg1, arg2)
				YssBossLoot.db.profile.zone = arg1
				---- need alot more logic here to get the first map since not all start at 1
				local baselevel, numlevels = YssBossLoot:GetLowestLevel(YssBossLoot.db.profile.maptype, arg1)
				YssBossLoot:SetMap(YssBossLoot.Maps[YssBossLoot.db.profile.maptype][arg1], baselevel)
				YssBossLoot:AddBosses(YssBossLoot.db.profile.maptype, arg1, baselevel, YssBossLootFrame.DetailFrame)
				YssBossLoot.db.profile.level = baselevel
				YssBossLootFrame.ZoneDropdown.text:SetText(arg2)
				if numlevels then
					YssBossLootFrame.LevelDropdown:Show()
					YssBossLootFrame.LevelDropdown.text:SetText(YssBossLoot:GetLevelName(YssBossLoot.db.profile.maptype, arg1, baselevel))
				else
					YssBossLootFrame.LevelDropdown:Hide()
				end
			end
			info.checked = RLnames[names[i]] == YssBossLoot.db.profile.zone
			UIDropDownMenu_AddButton(info, level)
		end
	elseif dropdowntype == 'level' then
		local MapType = YssBossLoot.db.profile.maptype
		local Map = YssBossLoot.db.profile.zone
		local levels = YssBossLoot.Levels[MapType][Map]
		local leveltable
		if type(levels) == 'table' then
			leveltable = levels
		else
			leveltable = {}
			for i=1, levels do
				leveltable[i] = i
			end
		end
		local levelsnames = {}
		for i=1, #leveltable do
			levelsnames[i] = YssBossLoot:GetLevelName(MapType, Map, leveltable[i])
		end
		for i = 1, #leveltable do
			info.text = levelsnames[i]
			info.arg1 = leveltable[i]
			info.arg2 = levelsnames[i]
			info.func = function(button, arg1, arg2)
				YssBossLoot:SetMap(YssBossLoot.Maps[MapType][Map], arg1)
				YssBossLoot:AddBosses(MapType, Map, arg1, YssBossLootFrame.DetailFrame)
				YssBossLoot.db.profile.level = arg1
				YssBossLootFrame.LevelDropdown.text:SetText(arg2)
			end
			info.checked = leveltable[i] == YssBossLoot.db.profile.level
			UIDropDownMenu_AddButton(info, level)
		end
	end
	DropDownList1:SetScale(YssBossLoot.db.profile.frame.scale)
end
local function dropdownClick(self)
	dropdowntype = self.type
	ToggleDropDownMenu(1, nil, YssBossLoot_DropDownMenu, self:GetParent(),11,7)
end
YssBossLootFrame.TypeDropdown.button:SetScript('OnClick', dropdownClick)
YssBossLootFrame.ZoneDropdown.button:SetScript('OnClick', dropdownClick)
YssBossLootFrame.LevelDropdown.button:SetScript('OnClick', dropdownClick)
