
local _, YssBossLoot = ...

if not YssBossLoot then
	_GYssBossLoot = _GYssBossLoot or {}
	YssBossLoot = _GYssBossLoot
end

local L = LibStub("AceLocale-3.0"):GetLocale("YssBossLoot", true)
local BZ = LibStub("LibBabble-Zone-3.0", true):GetUnstrictLookupTable()
local BB = LibStub("LibBabble-Boss-3.0", true):GetUnstrictLookupTable()

local WorldMapDetailFrame = _G['WorldMapDetailFrame']
local origSetTex = WorldMapDetailTile1.SetTexture
function WorldMapDetailTile1.SetTexture(self, tex, ...) --detect ingame map location
	origSetTex(self, tex, ...)
	YssBossLoot:ClearBosses(WorldMapDetailFrame)
	if not tex then return end
	local map , level = string.match(tex, "([^\\]+)(%d+)_%d+")
	if not map then
		map = string.match(tex, "([^\\]+)%d+")
		level = 0
	end
	level = tonumber(level)

	local _, instanceType = GetInstanceInfo() 
	if instanceType ~= 'none' then -- need to handle the none type better
		local mapTypes = {
			['party'] = 'Dungeon',
			['raid'] = 'Raid',
			['pvp'] = 'Battlegrounds',
		}
		local mapType = mapTypes[instanceType]
		if YssBossLoot.Maps['r'..mapType][map] then
			YssBossLoot:AddBosses(mapType, YssBossLoot.Maps['r'..mapType][map], level, WorldMapDetailFrame)
		end
	end
end